<template>
  <v-container class="pt-0">
    <v-row>
      <v-col class="py-0">
        <v-text-field
          v-model="model.searchString"
          append-icon="search"
          label="Search"
          single-line
          hide-details
          class="py-0 my-0"
          @input="$emit('input', model)"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col class="pt-0">
        <v-checkbox
          id="show-final-checkbox"
          v-model="model.showFinal"
          label="show final"
          hide-details
          @click="$emit('input', model)"
        />
      </v-col>
      <v-col class="pt-0">
        <v-checkbox
          v-model="model.caseSensitive"
          label="case sensitive"
          hide-details
          @click="$emit('input', model)"
        />
      </v-col>
      <v-col class="pt-0">
        <v-checkbox
          v-model="model.useRegex"
          hide-details
          @click="$emit('input', model)"
        >
          <template #label>
            use RegEx
            <v-tooltip top>
              <template #activator="{ on }">
                <a
                  href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp#character-classes"
                  target="_blank"
                  v-on="on"
                >
                  <v-icon>help</v-icon>
                </a>
              </template>
              <span>Go to RegEx documentation</span>
            </v-tooltip>
          </template>
        </v-checkbox>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-select
          v-model="model.filterByLabels"
          label="Label"
          :items="labels"
          return-object
          item-text="name"
          multiple
          hint="Filter by label"
          persistent-hint
          clearable
          @change="$emit('input', model)"
        />
      </v-col>
      <v-col>
        <v-select
          v-model="model.filterByExcludingLabels"
          label="Exclude label"
          :items="labels"
          item-text="name"
          return-object
          multiple
          hint="Filter by excluding labels"
          persistent-hint
          clearable
          @change="$emit('input', model)"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col
        v-if="isReviewer"
        md="6"
      >
        <v-select
          v-model="model.filterByTutors"
          label="Tutors"
          :items="tutors"
          item-text="username"
          return-object
          multiple
          hint="Filter by tutors"
          persistent-hint
          clearable
          @change="$emit('input', model)"
        />
      </v-col>
      <v-col
        v-if="model.filterByTutors.length > 0"
        md="6"
      >
        <v-select
          v-model="model.filterByStage"
          label="Stage"
          :items="feedbackStages"
          placeholder="All"
          hint="Filter after initial feedback or validated"
          persistent-hint
          clearable
          @change="$emit('input', model)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue, { PropType } from 'vue'
import Component from 'vue-class-component'
import { Authentication } from '@/store/modules/authentication'
import { TutorOverview } from '@/store/modules/tutor-overview'
import { FeedbackLabels } from '@/store/modules/feedback-labels'
import { Tutor, FeedbackLabel, FeedbackStageEnum, Exam } from '@/models'

export type FeedbackSearchOptionsModel = {
  searchString: string,
  showFinal: boolean,
  caseSensitive: boolean,
  useRegex: boolean,
  filterByExams: Exam[],
  filterByTutors: Tutor[],
  filterByStage: FeedbackStageEnum | undefined,
  filterByLabels: FeedbackLabel[],
  filterByExcludingLabels: FeedbackLabel[],
}

const FeedbackSearchOptionsProps = Vue.extend({
  props: {
    model: {
      type: Object as PropType<FeedbackSearchOptionsModel>,
      default: () => {
        return {
          searchString: '',
          showFinal: true,
          caseSensitive: false,
          useRegex: false,
          filterByExams: [],
          filterByTutors: [],
          filterByStage: undefined,
          filterByLabels: [],
          filterByExcludingLabels: [],
        }
      }
    }
  }
})

@Component
export default class FeedbackSearchOptions extends FeedbackSearchOptionsProps {
  feedbackStages = Object.entries(FeedbackStageEnum).map(([key, value]) => ({text: key, value}))

  get tutors() { return TutorOverview.state.tutors }
  get isReviewer() { return Authentication.isReviewer }

  get labels() {
    return FeedbackLabels.state.labels
  }

  loadTutors() {
    if (this.tutors.length === 0 && this.isReviewer) {
      TutorOverview.getTutors()
    }
  }

  created () {
    this.loadTutors()
  }
}
</script>

<style scoped>

</style>

